/*
 *   mwsetupk.h
 *
 *  Written By: Paul Schroeder IBM Corporation
 *
 *  Copyright (C) 1999 IBM Corporation
 *
 * This program is free software; you can redistribute it and/or modify      
 * it under the terms of the GNU General Public License as published by      
 * the Free Software Foundation; either version 2 of the License, or         
 * (at your option) any later version.                                       
 *                                                                           
 * This program is distributed in the hope that it will be useful,           
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
 * GNU General Public License for more details.                              
 *                                                                           
 * NO WARRANTY                                                               
 * THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR        
 * CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT      
 * LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,      
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is    
 * solely responsible for determining the appropriateness of using and       
 * distributing the Program and assumes all risks associated with its        
 * exercise of rights under this Agreement, including but not limited to     
 * the risks and costs of program errors, damage to or loss of data,         
 * programs or equipment, and unavailability or interruption of operations.  
 *                                                                           
 * DISCLAIMER OF LIABILITY                                                   
 * NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY   
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL        
 * DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND   
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR     
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE    
 * USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED  
 * HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES             
 *                                                                           
 * You should have received a copy of the GNU General Public License         
 * along with this program; if not, write to the Free Software               
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *                                                                           
 * 
 *  10/23/2000 - Alpha Release 0.1.0
 *            First release to the public
 *
 */
#ifndef _H_MWSETUPK
#define _H_MWSETUPK
//#pragma pack( push, WIN32_DEF, 8)

//
//  Definitions to allow both kernel-mode and user-mode drivers process this file.
//

//
#define FILE_DEVICE_MWAVE_SETUP 40001


//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
#define MWAVE_IOCTL_INDEX  2500


//
// The MWAVE device driver IOCTLs
//
#define IOCTL_MW_GET_THINKPAD_MODEL    (ULONG)(CTL_CODE(FILE_DEVICE_MWAVE_SETUP, \
                                       MWAVE_IOCTL_INDEX + 0, \
                                       METHOD_BUFFERED,       \
                                       FILE_ANY_ACCESS))


//
//  Definition of private interface structure used by user-mode components
//
typedef struct {
    unsigned uRequest;
    void   * pvInputBuf;
    unsigned uInputBufLen;
    void   * pvOutputBuf;
    unsigned uOutputBufLen;
    unsigned uStatus;
    unsigned uInputOutput1;
    unsigned uInputOutput2;
} SU_RequestPacket, *pSU_RequestPacket;


//
//  Values to be used with the "uRequest" field of the private interface structure
//
#define QUERY_SMAPI_PRESENT        0
#define QUERY_SMAPI_SYSTEM_ID      1


//
//  Status codes
//
#define SU_STATUS_SUCCESS             0
#define SU_STATUS_FAILED              1


/*=============================== Kernel driver only ==============================*/

// This is the Device extention struct definition:
//------------------------------------------------
typedef struct _SETUP_DEVICE_EXTENSION
{
    DEVICE_OBJECT     * pDevice;            // Pointer to our device object
    BOOLEAN             bMwavePresent;
    BOOLEAN             bSmapiPresent;
    unsigned            uMwaveModel;
    unsigned            uSetupDataDW1;
    unsigned            uSetupDataDW2;
} SETUP_DEVICE_EXTENSION, *pSETUP_DEVICE_EXTENSION;


#define DEVICE_NAME     L"\\Device\\MwSetupK"
#define DEVICE_LINK     L"\\DosDevices\\MwSetupK"


NTSTATUS
MwDispatchOpenClose(
         IN PDEVICE_OBJECT pDevice,
         IN PIRP Irp);

NTSTATUS
MwDispatchDeviceControl(
         IN PDEVICE_OBJECT pDevice,
         IN PIRP Irp);

VOID
MwStartIo (
         IN PDEVICE_OBJECT pDevice,
         IN PIRP Irp);

VOID
MwUnload(
         IN PDRIVER_OBJECT pDriverObject);


#ifdef MWAVE_DEBUG_INFO
#define MwavePrint(arg)    DbgPrint arg
#else
#define MwavePrint(arg)     
#endif

//#pragma pack( pop, WIN32_DEF)
#endif /* _H_MWSETUPK */

