/*
 *   unidiagx.h
 *
 *  Written By: Paul Schroeder IBM Corporation
 *
 *  Copyright (C) 1999 IBM Corporation
 *
 * This program is free software; you can redistribute it and/or modify      
 * it under the terms of the GNU General Public License as published by      
 * the Free Software Foundation; either version 2 of the License, or         
 * (at your option) any later version.                                       
 *                                                                           
 * This program is distributed in the hope that it will be useful,           
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
 * GNU General Public License for more details.                              
 *                                                                           
 * NO WARRANTY                                                               
 * THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR        
 * CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT      
 * LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,      
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is    
 * solely responsible for determining the appropriateness of using and       
 * distributing the Program and assumes all risks associated with its        
 * exercise of rights under this Agreement, including but not limited to     
 * the risks and costs of program errors, damage to or loss of data,         
 * programs or equipment, and unavailability or interruption of operations.  
 *                                                                           
 * DISCLAIMER OF LIABILITY                                                   
 * NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY   
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL        
 * DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND   
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR     
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE    
 * USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED  
 * HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES             
 *                                                                           
 * You should have received a copy of the GNU General Public License         
 * along with this program; if not, write to the Free Software               
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *                                                                           
 * 
 *  10/23/2000 - Alpha Release 0.1.0
 *            First release to the public
 *
 */
#ifndef unidiagx_H
#define unidiagx_H

/* Functions for the Unimodem diagnostic command (#UD) */
BOOL UniDiagsClearCallStatus(void);
BOOL MWM_ENTRY UniDiagsUpdateCallStatus(PMWM_DSPINFO);
BOOL UniDiagsSaveSetupInfo(PMWM_DSPINFO);
BOOL UniDiagsSaveOctets(PMWM_DSPINFO);
BOOL UniDiagsSaveConnectSpeed(PMWM_DSPINFO);
BOOL UniDiagsSaveLineInfo(PMWM_DSPINFO);
BOOL UniDiagsSaveInfoBits(PMWM_DSPINFO);
BOOL UniDiagsSaveCarrierInfo(PMWM_DSPINFO);
BOOL UniDiagsSaveProtocolInfo(PMWM_DSPINFO);
BOOL UniDiagsSaveDataFlowInfo(PMWM_DSPINFO);
BOOL UniDiagsSaveCallSetupResultInfo(PMWM_DSPINFO);
BOOL UniDiagsFinalCallStatus(PMWM_DSPINFO);
BOOL UniDiagsClearUARTCounters(PMWM_DSPINFO);
#endif

