/*
 *   dspdmfnc.h -- DSP Manager daemon functions prototypes/defines
 *
 *  Written By: Mike Sullivan IBM Corporation
 *
 *  Copyright (C) 1999 IBM Corporation
 *
 * This program is free software; you can redistribute it and/or modify      
 * it under the terms of the GNU General Public License as published by      
 * the Free Software Foundation; either version 2 of the License, or         
 * (at your option) any later version.                                       
 *                                                                           
 * This program is distributed in the hope that it will be useful,           
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
 * GNU General Public License for more details.                              
 *                                                                           
 * NO WARRANTY                                                               
 * THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR        
 * CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT      
 * LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,      
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is    
 * solely responsible for determining the appropriateness of using and       
 * distributing the Program and assumes all risks associated with its        
 * exercise of rights under this Agreement, including but not limited to     
 * the risks and costs of program errors, damage to or loss of data,         
 * programs or equipment, and unavailability or interruption of operations.  
 *                                                                           
 * DISCLAIMER OF LIABILITY                                                   
 * NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY   
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL        
 * DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND   
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR     
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE    
 * USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED  
 * HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES             
 *                                                                           
 * You should have received a copy of the GNU General Public License         
 * along with this program; if not, write to the Free Software               
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *                                                                           
 * 
 *  10/23/2000 - Alpha Release 0.1.0
 *            First release to the public
 *
 */
#include "dspsrv.h"

/****************************************************************************/
/* Function Prototypes                                                      */
/****************************************************************************/
VOID DAEMON_DspAllocateSegment(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspChangeCPF(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspChangeDMA(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspChangeModuleState(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspChangeTaskState(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspConnectGPC(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspConnectIPC(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspConnectITCB(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspDisconnectIPC(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspDisconnectGPC(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspDisconnectITCB(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspFreeModule(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspFreeSegment(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspFreeTask(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspInit(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspLabelToOffset(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspLoadModule(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspLoadTask(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspLoadSegment(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspLockMem(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspNameToModuleHandle(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspNameToSegmentHandle(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspNameToTaskHandle(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspQueryDSPInfo(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspQueryManagerInfo(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspQueryMiscInfo(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspQueryModuleInfo(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspQueryTaskInfo(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspUnLockMem(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspAbilities(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspReset(PMWMGR_ANSWER_HEAD pAnsHead);
VOID DAEMON_DspRun(PMWMGR_ANSWER_HEAD pAnsHead);
RC   DAEMON_DspVerifyPointer(PVOID ptr);
